0001 ADUMP   ORG 0C950H   * LOADING ADDRESS
0002 *
0003 *
0004 * <*>  ROUTINE TO DUMP ASCII EQUIVALENT OF MEMORY.
0005 * MODIFIED VERSION OF DUMP ROUTINE FROM SOLOS (TM)
0006 * COPYRIGHT 1977; PROCESSOR TECHNOLOGY CORP.
0007 *      MODIFIED BY DON VAN DYKE
0008 *** DR. DOBBS JOURNAL # 21 (VOL.3, ISSUE 1)
0009 *
0010 *
0011 DUMP   CALL SCONV     * SCAN TO 1ST ADDRESS & CONVERT IT
0012        PUSH H         * SAVE THE VALUE
0013        CALL PSCAN     * SEE IF SECOND WAS GIVEN
0014        POP  D         * GET BACK START
0015        XCHG           * "HL" HAS START; "DE" HAS END
0016 DLOOP  CALL CRLF
0017        CALL ADOUT     * OUTPUT ADDRESS
0018        CALL BOUT      * ANOTHER SPACE TO KEEP IT PRETTY
0019        MVI  C,16      * VALUES PER LINE
0020 DLP1   MOV  A,M       * GET THE CHR
0021        PUSH B         * SAVE VALUE COUNT
0022        CPI  20H       * < 20H ?
0023        JNC  DOWN
0024        MVI  A,'.'     * ...YES, MAKE IT A DOT
0025 DOWN   CPI  7FH       * >= 7FH ?
0026        JC   DN1       * ...NO
0027        MVI  A,'.'     * ...YES,MAKE THIS A DOT
0028 DN1    MOV  B,A       * PUT IT IN "B"
0029        CALL SOUT      * PUT IT OUT
0030        MVI  B,' '
0031        CALL SOUT      * PUT OUT A BLANK
0032        MOV  A,L       * COMPARE "DE" & "HL"
0033        SUB  E
0034        MOV  A,H
0035        SBB  D
0036        JNC  COMND     * ALL DONE
0037        POP  B         * VALUES PER LINE
0038        INX  H
0039        DCR  C         * BUMP THE LINE COUNT
0040        JNZ  DLP1      * NOT ZERO IF MORE FOR THIS LINE
0041        JMP  DLOOP     * DO A LFCR BEFORE THE NEXT
0042 SOUT   EQU  0C019H    * SYSTEM ENTRY POINT: OUTPUT PORT
0043 SCONV  EQU  0C33AH    *    "   ROUTINE: CONV CHAR. 2 HEX
0044 COMND  EQU  0C1C9H    *    "      "   : PROCESS COMMANDS
0045 ADOUT  EQU  0C3E8H    * " ": OUTPUT 'HL' AS HEX 16 BIT VAL
0046 BOUT   EQU  0C406H    * PART OF ABOVE ROUTINE
0047 PSCAN  EQU  0C310H    * SYS. ROUTINE: SCAN OFF OPT. PARAM.
0048 CRLF   EQU  0C2F9H    * " ": OUTPUT LINE FEED & CARR. RET.
0049 *
0050 ENDIT  END
