0001 EXAM   ORG 0C900H   * LOADING ADDRESS
0002 *
0003 *  <<< PROGRAM TO DISPLAY THE ASCII OF MEMORY CONTENTS >>>
0004 ****** WRITTEN BY DON VAN DYKE : DR. DOBBS JOURNAL # 21
0005 ****** (VOL.3, ISSUE 3)
0006 *
0007        XRA  A      * INITIALIZE SCREEN
0008        OUT  0FEH   * SET SOL
0009        OUT  0C8H   * SET VDM
0010        LXI  B,OFFST  * (-2048)
0011        LXI  D,0      * BEGINNING OF MEMORY
0012 NEXT   CALL DISP     * DISPLAY 1K
0013 IN     CALL SINP     * GET CHARACTER FROM SOLOS/CUTER
0014        JZ   IN       * READY ?
0015        ANI  7FH      * STRIP PARITY
0016        CPI  1BH      * ESCAPE KEY HIT ?
0017        JZ   RETRN    * ...YES, RETURN TO SOLOS
0018        CPI  9        * TAB OR CTRL-I ?
0019        JZ   TAB      * ...YES
0020        CPI  17H      * UP ARROW OR CTNL-W KEY ?
0021        JZ   NEXT     * ...YES
0022        CPI  1AH      * DOWN ARROW OR CTRL-Z ?
0023        JZ   BACK     * ...YES
0024        JMP  IN       * IF NONE OF THESE, THEN TRY ANOTHER CH.
0025 *
0026 * <*> ROUTINE TO SKIP 8K AND DISPLAY <*>
0027 *
0028 TAB    XCHG
0029        LXI  D,2000H  * 8K TO SKIP
0030        DAD  D        * ADD THE OFFSET
0031        XCHG
0032        JMP  DISP     * DISPLAY IT
0033 *
0034 BACK   XCHG
0035        DAD  B        * SUBTRACT 2K
0036        XCHG
0037 *
0038 DISP   LXI  H,VDM    * BEGINNING OF DISPLAY
0039 AGAIN  LDAX D        * GET THE CHARACTER FROM MEMORY
0040        MOV  M,A      * PUT IT ON THE SCREEN
0041        INX  D        * NEXT MEMORY LOCATION
0042        INX  H        * NEXT SCREEN LOCATION
0043        MOV  A,H      * GET HIGH ORDER ADDRESS
0044        CPI  0D0H     * END OF SCREEN ADDRESS ?
0045        JNZ  AGAIN    * ...NO, DO IT AGAIN
0046        JMP  IN       * GET ANOTHER CHARACTER
0047 SINP   EQU  0C01FH   *** SYSTEM I/O ENTRY PORT (INPUT)
0048 VDM    EQU  0CC00H
0049 RETRN  EQU  0C004H
0050 OFFST  EQU  0F800H
0051 ******
0052 ENDIT  END
