0001 *
0002 ***    ALS-8  I/O DRIVERS   (serial and keyboard)
0003 *
0004 *
0005 * ::: INPUT DRIVER
0006 *
0007 INPUT  IN   SSTAT    * Get serial status
0008        CMA           * Invert it
0009        ANI  SAVL     * Serial data available ?
0010        JZ   SINPT    * Yes, input serial data
0011        IN   KSTAT    * Get keyboard status
0012        CMA           * Invert it
0013        ANI  KAVL     * Keyboard data available ?
0014        JZ   KINPT    * Yes, input keyboard data
0015        JMP  INPUT    * No, loop around again
0016 *
0017 SINPT  IN   SDATA    * Input data from the serial port
0018        ANI  STRIP    * Strip the parity bit
0019        MOV  B,A      * Save a copy
0020        JMP  VDMIO    * Return to ALS-8
0021 *
0022 KINPT  IN   KDATA    * Input data from the keyboard
0023        ANI  STRIP    * Strip the parity bit
0024        MOV  B,A      * Save a copy
0025        CPI  ESC      * Escape key ?
0026        JZ   EORMS    * Yes, change drivers & give READY
0027 *
0028 *
0029 *** EQUATES ***
0030 *
0031 SSTAT  0F8H
0032 SAVL   040H
0033 KSTAT  0FAH
0034 KAVL   001H
0035 SDATA  0F9H
0036 KDATA  0FCH
0037 STRIP  07FH
0038 ESC    01BH
0039 VDMIO  0FE77H
0049 EORMS  0E060H
0050 *
0051          END
