0001 ORG  ORG 0C900H  * "START-OF-PROGRAM" ADDRESS
0002 *    This will load INTEL format paper tape
0003 *  into a SOL thru an OP80 paper tape reader
0004 *  connected to a SOL parallel data interface.
0005 *
0006 *
0007 START  MVI   A,010H   *  Startup
0008        OUT   0FAH
0009        CALL  DAZL
0010 *
0011 PTIN   IN    0FAH     *  Input from OP80 asc.
0012        ANI   002H
0013        JNZ   PTIN
0014        MVI   A,000H
0015        OUT   0FAH     *  Toggle ACK
0016        MVI   A,010H
0017        OUT   0FAH
0018        IN    0FDH
0019        ANI   07FH
0020        RET
0021 *
0022 HEX    SUI   030H      *  Convert ASC to HEX
0023        CPI   00AH
0024        RC
0025        SUI   007H
0026        RET
0027 *
0028 CHAR   CALL  PTIN      *  Assemble BYTE
0029        CALL  HEX
0030        CALL  ROLL
0031        MOV   E,A
0032        CALL  PTIN
0033        CALL  HEX
0034        ADD   E
0035        RET
0036 *
0037 ROLL   RLC
0038        RAL
0039        RAL
0040        RAL
0041        RET
0042 *
0043 CARD   CALL  PTIN    *  Assm byte, display
0044        PUSH  006H
0045        MOV   B,A
0046        CALL  SOUT
0047        POP   006H
0048        CALL  HEX
0049        CALL  ROLL
0050        MOV   E,A
0051        CALL  PTIN
0052        PUSH  006H
0053        MOV   B,A
0054        CALL  SOUT
0055        POP   006H
0056        CALL  HEX
0057        ADD   E
0058        RET
0059 *
0060 LOOP   CALL  CHAR    *  Input data
0061        MOV   M,A
0062        INX   H
0063        DCR   D
0064        JNZ   LOOP
0065        JMP   READ
0066 *
0067 READ   CALL  PTIN    *  Look for a block
0068        CPI   03AH
0069        JNZ   READ
0070 RDI    MVI   B,00AH
0071        CALL  SOUT
0072        MVI   B,00DH
0073        CALL  SOUT
0074        CALL  CARD
0075        MOV   D,A
0076        RZ
0077        MVI   B,00AH
0078        CALL  SOUT
0079        MVI   B,00DH
0080        CALL  SOUT
0081        CALL  CARD
0082        MOV   H,A
0083        CALL  CARD
0084        MOV   L,A
0085        CALL  CHAR
0086        JMP   LOOP
0087 *
0088 DAZL   CALL  PTIN
0089        CPI   03AH
0090        JNZ   WAIT
0091        JMP   RDI
0092 WAIT   MOV   B,A
0093        CALL  SOUT
0094        JMP   DAZL
0095 *
0096 SOUT   EQU   0C019H
0097 *
0098 *
0099 *
0100 *   CABLE PINOUT
0101 *
0102 *  SOL.........OP80
0103 * REV. E     PIN   SIGNAL
0104 *   13        1     ID0
0105 *   12       16     ID1
0106 *   11        2     ID2
0107 *   10       15     ID3
0108 *    9        3     ID4
0109 *    8       14     ID5
0110 *    7        4     ID6
0111 *    6       13     ID7
0112 *
0113 *   14        5     ACK-
0114 *    4        6     RDA-
0115 *    2        8     GND
0116 *             9     +5V
0117 ****
0118 *
0119 *
0120 END  END
