0010 *
0020 ***   ALS-8  I/O DRIVERS   (Serial and Keyboard)
0030 *
0040 *
0050 * ::: INPUT DRIVER
0060 *
0070 INPUT  CALL STAT1  * Get Serial status
0080        JNZ  SINPT  * Input a char.
0090 INPU1  CALL STAT0  * Get Keyboard status
0100        JZ   INPUT  * Busy loop.
0110        IN   KDATA  * Keyboard INPUT
0120        ANI  STRIP  * Strip parity.
0130        MOV  B,A    * Save a copy
0140        RET
0150 *
0160 SINPT  IN   SDATA  * Input it from serial port.
0170        ANI  STRIP  * Strip parity
0180        MOV  B,A    * Save a copy
0190        JMP  INPU1
0200 *
0210 STAT0  IN   KSTAT  * Get status
0220        CMA         * Invert it
0230        ANI  KAVL   * Check for data available.
0240        RET
0250 *
0260 STAT1  IN   SSTAT  * Get serial status
0270        CMA         * Invert it
0280        ANI  SAVL   * Check for data available.
0290        RET
0300 *
0310 *
0320 *
0330 KDATA  EQU 0FCH
0340 SDATA  EQU 0F9H
0350 KSTAT  EQU 0FAH
0360 SSTAT  EQU 0F8H
0370 KAVL   EQU 001H
0380 SAVL   EQU 040H
0390 STRIP  EQU 07FH
0400 *
0410 ENDIT  END
